(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("redux-watch"));
	else if(typeof define === 'function' && define.amd)
		define(["redux-watch"], factory);
	else if(typeof exports === 'object')
		exports["InitializeGetHistory"] = factory(require("redux-watch"));
	else
		root["InitializeGetHistory"] = factory(root["redux-watch"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _reduxWatch = __webpack_require__(1);
	
	var _reduxWatch2 = _interopRequireDefault(_reduxWatch);
	
	var _index = __webpack_require__(2);
	
	var _index2 = _interopRequireDefault(_index);
	
	var _actions = __webpack_require__(5);
	
	var Actions = _interopRequireWildcard(_actions);
	
	var _actionStatuses = __webpack_require__(4);
	
	var ActionStatuses = _interopRequireWildcard(_actionStatuses);
	
	var _nextitRequestHandlerHistory = __webpack_require__(6);
	
	var _nextitRequestHandlerHistory2 = _interopRequireDefault(_nextitRequestHandlerHistory);
	
	var _nextitResponseHandlerHistory = __webpack_require__(7);
	
	var _nextitResponseHandlerHistory2 = _interopRequireDefault(_nextitResponseHandlerHistory);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var InitializeGetHistory = function () {
	    function InitializeGetHistory(settings) {
	        _classCallCheck(this, InitializeGetHistory);
	
	        this._settings = settings;
	    }
	
	    _createClass(InitializeGetHistory, [{
	        key: 'getReducer',
	        value: function getReducer() {
	            return _index2.default;
	        }
	    }, {
	        key: 'initialize',
	        value: function initialize(store) {
	            this._store = store;
	
	            var stateLocations = this._settings.stateLocations;
	
	            initWatcher = (0, _reduxWatch2.default)(this.store.getState, stateLocations.Initialization.Base);
	
	            this._store.subscribe(initWatcher(this.handleInitialize));
	        }
	    }, {
	        key: 'handleInitialize',
	        value: function handleInitialize(newVal, oldVal, objectPath) {
	            var data = {
	                input: {
	                    messageType: this._settings.messageConstants.getHistoryMessageType,
	                    messageLimit: this._settings.History.messageLimit,
	                    includeRevertedEntries: this._settings.History.includeRevertedEntries
	                },
	                stateLocation: this._settings.stateLocations.History.stagedInput
	            };
	
	            this._store.dispatch(Actions.restoreChatHistory(data));
	        }
	    }, {
	        key: 'getRequestHandler',
	        value: function getRequestHandler() {
	            return new _nextitRequestHandlerHistory2.default(this._settings);
	        }
	    }, {
	        key: 'getResponseHandler',
	        value: function getResponseHandler() {
	            return new _nextitResponseHandlerHistory2.default(this._settings);
	        }
	    }]);
	
	    return InitializeGetHistory;
	}();
	
	exports.default = InitializeGetHistory;

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = require("redux-watch");

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = reducer;
	
	var _actionTypes = __webpack_require__(3);
	
	var _actionStatuses = __webpack_require__(4);
	
	var ActionStatuses = _interopRequireWildcard(_actionStatuses);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	function reducer() {
	    var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
	    var action = arguments[1];
	
	    var loc = {};
	    var response = {};
	    switch (action.type) {
	        case _actionTypes.RESTORE_CHAT_HISTORY:
	            var newInput = action.payload.input;
	            var stateLoc = action.payload.stateLocation;
	            var newState = Object.assign({}, state[stateLoc], {
	                input: newInput
	            });
	
	            return Object.assign({}, state, _defineProperty({}, stateLoc, newState));
	            break;
	
	        case _actionTypes.SEND_HISTORY_REQUEST:
	            switch (action.status) {
	                case ActionStatuses.begin:
	                    //we reall don't care right now
	                    break;
	
	                case ActionStatuses.processing:
	                    var responseLoc = action.payload.stateLocation;
	
	                    response = {
	                        responses: action.payload.response,
	                        responseType: action.payload.responseType
	                    };
	
	                    return Object.assign({}, state, _defineProperty({}, responseLoc, response));
	                    break;
	
	                case ActionStatuses.complete:
	                    loc = action.payload.stateLocation;
	                    var messages = action.payload.messages;
	
	                    var newMessages = state[loc].concat(messages);
	
	                    return Object.assign({}, state, _defineProperty({}, loc, newMessages));
	                    break;
	
	                case ActionStatuses.error:
	                    loc = action.payload.stateLocation;
	                    response = {
	                        error: true,
	                        message: action.payload.response
	                    };
	
	                    return Object.assign({}, state, _defineProperty({}, loc, response));
	                    break;
	
	                default:
	                    return state;
	            }
	            break;
	
	        default:
	            return state;
	    }
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var RESTORE_CHAT_HISTORY = exports.RESTORE_CHAT_HISTORY = 'RESTORE_CHAT_HISTORY';
	var SEND_HISTORY_REQUEST = exports.SEND_HISTORY_REQUEST = "SEND_HISTORY_REQUEST";

/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var begin = exports.begin = "begin";
	var processing = exports.processing = "processing";
	var error = exports.error = "error";
	var complete = exports.complete = "complete";

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.restoreChatHistory = restoreChatHistory;
	exports.sendHistoryRequest = sendHistoryRequest;
	exports.receivedHistoryResponse = receivedHistoryResponse;
	
	var _actionTypes = __webpack_require__(3);
	
	var _actionStatuses = __webpack_require__(4);
	
	var ActionStatuses = _interopRequireWildcard(_actionStatuses);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function restoreChatHistory(data) {
	    return {
	        type: _actionTypes.RESTORE_CHAT_HISTORY,
	        payload: data
	    };
	}
	
	function sendHistoryRequest(request, responseType, responseLoc, historyRetriever) {
	    return function (dispatch) {
	        dispatch(historyRequest(ActionStatuses.begin, request));
	
	        historyRetriever.getHistoryAsync(request).then(function (response) {
	            return response.json();
	        }).then(function (data) {
	            dispatch(historyRequest(ActionStatuses.processing, {
	                stateLocation: responseLoc,
	                responseType: responseType,
	                response: data
	            }));
	        }).catch(function (err) {
	            dispatch(historyRequest(ActionStatuses.error, {
	                stateLocation: responseLoc,
	                response: err
	            }, true));
	        });
	    };
	}
	
	function receivedHistoryResponse(messages, stateLocation) {
	    return {
	        type: _actionTypes.SEND_HISTORY_REQUEST,
	        payload: {
	            messages: messages,
	            stateLocation: stateLocation
	        },
	        status: ActionStatuses.complete
	    };
	}
	
	var historyRequest = function historyRequest(status, payload, error) {
	    return {
	        type: _actionTypes.SEND_HISTORY_REQUEST,
	        status: status,
	        payload: payload,
	        error: error
	    };
	};

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _actions = __webpack_require__(5);
	
	var Actions = _interopRequireWildcard(_actions);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var GetHistoryRequestHandler = function () {
	    function GetHistoryRequestHandler(almeApi, settings) {
	        _classCallCheck(this, GetHistoryRequestHandler);
	
	        this._almeApi = almeApi;
	        this._settings = settings;
	    }
	
	    _createClass(GetHistoryRequestHandler, [{
	        key: 'initialize',
	        value: function initialize(store) {
	            this._dispatch = store.dispatch;
	        }
	    }, {
	        key: 'handle',
	        value: function handle(input) {
	            if (!this.doesHandle(input)) return;
	
	            var receivedResponseLoc = this._settings.stateLocations.Conversation.receivedResponse;
	
	            var HistoryRequest = this._almeApi.dataTypes().HistoryRequestDetails;
	
	            var request = new HistoryRequest(input.userId, input.sessionId, input.messageLimit, input.includeRevertedEntries);
	
	            var responseType = this._settings.messageConstants.getHistoryRequest;
	
	            this._dispatch(sendHistoryRequest(request, responseType, receivedResponseLoc, this._almeApi.historyRetriever()));
	        }
	    }, {
	        key: 'doesHandle',
	        value: function doesHandle(input) {
	            return input.messageType === this._settings.messageConstants.getHistoryRequest;
	        }
	    }]);
	
	    return GetHistoryRequestHandler;
	}();
	
	exports.default = GetHistoryRequestHandler;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _actions = __webpack_require__(5);
	
	var Actions = _interopRequireWildcard(_actions);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var GetHistoryResponseHandler = function () {
	    function GetHistoryResponseHandler(settings) {
	        _classCallCheck(this, GetHistoryResponseHandler);
	
	        this._settings = settings;
	    }
	
	    _createClass(GetHistoryResponseHandler, [{
	        key: 'initialize',
	        value: function initialize(store) {
	            this._store = store;
	        }
	    }, {
	        key: 'process',
	        value: function process(response) {
	            if (!this.doesHandle(response)) return;
	
	            var responses = response.responses || [];
	            var stateLocation = this._settings.History.Messages;
	
	            var stagableResponses = responses.map(this.mapResponses).reduce(this.reduceResponses);
	
	            this._store.dispatch(Actions.receivedHistoryResponse(stagableResponses, stateLocation));
	        }
	    }, {
	        key: 'mapResponses',
	        value: function mapResponses(value) {
	
	            var userInput = {
	                type: this._settings.messageConstants.userInputType,
	                text: value.maskedInput,
	                userDisplyName: value.userDisplayName
	            };
	
	            var almeResponse = {
	                type: this._settings.messageConstants.almeResponseType,
	                html: value.text,
	                agentDisplayName: value.agentDisplayName
	            };
	
	            return [userInput, agentResponse];
	        }
	    }, {
	        key: 'reduceResponses',
	        value: function reduceResponses(prev, cur) {
	            return prev.concat(cur);
	        }
	    }, {
	        key: 'doesHandle',
	        value: function doesHandle(response) {
	            return response.responseType === this._settings.messageConstants.getHistoryRequest;
	        }
	    }]);
	
	    return GetHistoryResponseHandler;
	}();
	
	exports.default = GetHistoryResponseHandler;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=nextit-initialization-gethistory.js.map